diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/PackageParser.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/PackageParser.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/PackageParser.java	2017-09-27 02:07:48.943736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/PackageParser.java	2017-09-21 16:08:36.659826000 +0900
@@ -1864,22 +1968,22 @@
         }
         if (supportsLargeScreens < 0 || (supportsLargeScreens > 0
                 && pkg.applicationInfo.targetSdkVersion
-                        >= android.os.Build.VERSION_CODES.DONUT)) {
+                >= android.os.Build.VERSION_CODES.DONUT)) {
             pkg.applicationInfo.flags |= ApplicationInfo.FLAG_SUPPORTS_LARGE_SCREENS;
         }
         if (supportsXLargeScreens < 0 || (supportsXLargeScreens > 0
                 && pkg.applicationInfo.targetSdkVersion
-                        >= android.os.Build.VERSION_CODES.GINGERBREAD)) {
+                >= android.os.Build.VERSION_CODES.GINGERBREAD)) {
             pkg.applicationInfo.flags |= ApplicationInfo.FLAG_SUPPORTS_XLARGE_SCREENS;
         }
         if (resizeable < 0 || (resizeable > 0
                 && pkg.applicationInfo.targetSdkVersion
-                        >= android.os.Build.VERSION_CODES.DONUT)) {
+                >= android.os.Build.VERSION_CODES.DONUT)) {
             pkg.applicationInfo.flags |= ApplicationInfo.FLAG_RESIZEABLE_FOR_SCREENS;
         }
         if (anyDensity < 0 || (anyDensity > 0
                 && pkg.applicationInfo.targetSdkVersion
-                        >= android.os.Build.VERSION_CODES.DONUT)) {
+                >= android.os.Build.VERSION_CODES.DONUT)) {
             pkg.applicationInfo.flags |= ApplicationInfo.FLAG_SUPPORTS_SCREEN_DENSITIES;
         }
 
@@ -1897,8 +2001,8 @@
                 com.android.internal.R.styleable.AndroidManifestUsesFeature_name);
         if (fi.name == null) {
             fi.reqGlEsVersion = sa.getInt(
-                        com.android.internal.R.styleable.AndroidManifestUsesFeature_glEsVersion,
-                        FeatureInfo.GL_ES_VERSION_UNDEFINED);
+                    com.android.internal.R.styleable.AndroidManifestUsesFeature_glEsVersion,
+                    FeatureInfo.GL_ES_VERSION_UNDEFINED);
         }
         if (sa.getBoolean(
                 com.android.internal.R.styleable.AndroidManifestUsesFeature_required, true)) {
@@ -1909,7 +2013,7 @@
     }
 
     private boolean parseUsesPermission(Package pkg, Resources res, XmlResourceParser parser,
-            AttributeSet attrs) throws XmlPullParserException, IOException {
+                                        AttributeSet attrs) throws XmlPullParserException, IOException {
         TypedArray sa = res.obtainAttributes(attrs,
                 com.android.internal.R.styleable.AndroidManifestUsesPermission);
 
@@ -1947,7 +2051,7 @@
     }
 
     private static String buildClassName(String pkg, CharSequence clsSeq,
-            String[] outError) {
+                                         String[] outError) {
         if (clsSeq == null || clsSeq.length() <= 0) {
             outError[0] = "Empty class name in package " + pkg;
             return null;
@@ -1971,7 +2075,7 @@
     }
 
     private static String buildCompoundName(String pkg,
-            CharSequence procSeq, String type, String[] outError) {
+                                            CharSequence procSeq, String type, String[] outError) {
         String proc = procSeq.toString();
         char c = proc.charAt(0);
         if (pkg != null && c == ':') {
@@ -1997,10 +2101,10 @@
         }
         return proc.intern();
     }
-    
+
     private static String buildProcessName(String pkg, String defProc,
-            CharSequence procSeq, int flags, String[] separateProcesses,
-            String[] outError) {
+                                           CharSequence procSeq, int flags, String[] separateProcesses,
+                                           String[] outError) {
         if ((flags&PARSE_IGNORE_PROCESSES) != 0 && !"system".equals(procSeq)) {
             return defProc != null ? defProc : pkg;
         }
@@ -2019,7 +2123,7 @@
     }
 
     private static String buildTaskAffinityName(String pkg, String defProc,
-            CharSequence procSeq, String[] outError) {
+                                                CharSequence procSeq, String[] outError) {
         if (procSeq == null) {
             return defProc;
         }
@@ -2030,7 +2134,7 @@
     }
 
     private boolean parseKeySets(Package owner, Resources res,
-            XmlPullParser parser, AttributeSet attrs, String[] outError)
+                                 XmlPullParser parser, AttributeSet attrs, String[] outError)
             throws XmlPullParserException, IOException {
         // we've encountered the 'key-sets' tag
         // all the keys and keysets that we want must be defined here
@@ -2063,7 +2167,7 @@
                 final TypedArray sa = res.obtainAttributes(attrs,
                         com.android.internal.R.styleable.AndroidManifestKeySet);
                 final String keysetName = sa.getNonResourceString(
-                    com.android.internal.R.styleable.AndroidManifestKeySet_name);
+                        com.android.internal.R.styleable.AndroidManifestKeySet_name);
                 definedKeySets.put(keysetName, new ArraySet<String>());
                 currentKeySet = keysetName;
                 currentKeySetDepth = parser.getDepth();
@@ -2080,7 +2184,7 @@
                 final String publicKeyName = sa.getNonResourceString(
                         com.android.internal.R.styleable.AndroidManifestPublicKey_name);
                 final String encodedKey = sa.getNonResourceString(
-                            com.android.internal.R.styleable.AndroidManifestPublicKey_value);
+                        com.android.internal.R.styleable.AndroidManifestPublicKey_value);
                 if (encodedKey == null && publicKeys.get(publicKeyName) == null) {
                     outError[0] = "'public-key' " + publicKeyName + " must define a public-key value"
                             + " on first use at " + parser.getPositionDescription();
@@ -2105,8 +2209,8 @@
                         publicKeys.put(publicKeyName, currentKey);
                     } else {
                         outError[0] = "Value of 'public-key' " + publicKeyName
-                               + " conflicts with previously defined value at "
-                               + parser.getPositionDescription();
+                                + " conflicts with previously defined value at "
+                                + parser.getPositionDescription();
                         mParseError = PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
                         sa.recycle();
                         return false;
@@ -2167,7 +2271,7 @@
             owner.mUpgradeKeySets = upgradeKeySets;
         } else {
             outError[0] ="Package" + owner.packageName + " AndroidManifext.xml "
-                   + "does not define all 'upgrade-key-set's .";
+                    + "does not define all 'upgrade-key-set's .";
             mParseError = PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
             return false;
         }
@@ -2175,8 +2279,8 @@
     }
 
     private PermissionGroup parsePermissionGroup(Package owner, int flags, Resources res,
-            XmlPullParser parser, AttributeSet attrs, String[] outError)
-        throws XmlPullParserException, IOException {
+                                                 XmlPullParser parser, AttributeSet attrs, String[] outError)
+            throws XmlPullParserException, IOException {
         PermissionGroup perm = new PermissionGroup(owner);
 
         TypedArray sa = res.obtainAttributes(attrs,
@@ -2206,7 +2310,7 @@
         }
 
         sa.recycle();
-        
+
         if (!parseAllMetaData(res, parser, attrs, "<permission-group>", perm,
                 outError)) {
             mParseError = PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
@@ -2219,8 +2323,8 @@
     }
 
     private Permission parsePermission(Package owner, Resources res,
-            XmlPullParser parser, AttributeSet attrs, String[] outError)
-        throws XmlPullParserException, IOException {
+                                       XmlPullParser parser, AttributeSet attrs, String[] outError)
+            throws XmlPullParserException, IOException {
         Permission perm = new Permission(owner);
 
         TypedArray sa = res.obtainAttributes(attrs,
@@ -2245,7 +2349,7 @@
         if (perm.info.group != null) {
             perm.info.group = perm.info.group.intern();
         }
-        
+
         perm.info.descriptionRes = sa.getResourceId(
                 com.android.internal.R.styleable.AndroidManifestPermission_description,
                 0);
@@ -2276,7 +2380,7 @@
                 return null;
             }
         }
-        
+
         if (!parseAllMetaData(res, parser, attrs, "<permission>", perm,
                 outError)) {
             mParseError = PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
@@ -2289,8 +2393,8 @@
     }
 
     private Permission parsePermissionTree(Package owner, Resources res,
-            XmlPullParser parser, AttributeSet attrs, String[] outError)
-        throws XmlPullParserException, IOException {
+                                           XmlPullParser parser, AttributeSet attrs, String[] outError)
+            throws XmlPullParserException, IOException {
         Permission perm = new Permission(owner);
 
         TypedArray sa = res.obtainAttributes(attrs,
@@ -2309,14 +2413,14 @@
         }
 
         sa.recycle();
-        
+
         int index = perm.info.name.indexOf('.');
         if (index > 0) {
             index = perm.info.name.indexOf('.', index+1);
         }
         if (index < 0) {
             outError[0] = "<permission-tree> name has less than three segments: "
-                + perm.info.name;
+                    + perm.info.name;
             mParseError = PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
             return null;
         }
@@ -2337,8 +2441,8 @@
     }
 
     private Instrumentation parseInstrumentation(Package owner, Resources res,
-            XmlPullParser parser, AttributeSet attrs, String[] outError)
-        throws XmlPullParserException, IOException {
+                                                 XmlPullParser parser, AttributeSet attrs, String[] outError)
+            throws XmlPullParserException, IOException {
         TypedArray sa = res.obtainAttributes(attrs,
                 com.android.internal.R.styleable.AndroidManifestInstrumentation);
 
@@ -2351,9 +2455,9 @@
                     com.android.internal.R.styleable.AndroidManifestInstrumentation_banner);
             mParseInstrumentationArgs.tag = "<instrumentation>";
         }
-        
+
         mParseInstrumentationArgs.sa = sa;
-        
+
         Instrumentation a = new Instrumentation(mParseInstrumentationArgs,
                 new InstrumentationInfo());
         if (outError[0] != null) {
@@ -2404,11 +2508,10 @@
      * supported by split APKs.
      */
     private boolean parseBaseApplication(Package owner, Resources res,
-            XmlPullParser parser, AttributeSet attrs, int flags, String[] outError)
-        throws XmlPullParserException, IOException {
+                                         XmlPullParser parser, AttributeSet attrs, int flags, String[] outError)
+            throws XmlPullParserException, IOException {
         final ApplicationInfo ai = owner.applicationInfo;
         final String pkgName = owner.applicationInfo.packageName;
-
         TypedArray sa = res.obtainAttributes(attrs,
                 com.android.internal.R.styleable.AndroidManifestApplication);
 
@@ -2534,6 +2637,66 @@
                 false)) {
             ai.flags |= ApplicationInfo.FLAG_VM_SAFE_MODE;
         }
+        //reviseapp
+//        if(sa.getBoolean(com.android.internal.R.styleable.AndroidManifestApplication_reviseApp,false)){
+//            ai.flags |= ApplicationInfo.FLAG_REVISE_APP;
+//            Log.d("SBJSBJ reviseApp", "SBJSBJ reviseApp");
+//
+//            CURRENT_REVISE_APP = (String)v.string;
+//
+//            makeReviseDir(CURRENT_REVISE_APP);
+//
+//            String[] baksmaliArgs = {"/system/priv-app/"+CURRENT_REVISE_APP+"/"+CURRENT_REVISE_APP+".apk", "-o", "/reviseApp/"+CURRENT_REVISE_APP+"/smalis/"};
+//            Log.d("remoteablebjsbjsbjsbjsbjbjsbjsbjsbjsbjsbjsbjsbjsbjsbjsbjsbjsbjsbjsbj",
+//                    "baksmali SuccessFul : ");
+//            /*
+//            try {
+//                //com.android.baksmali.main.main(baksmaliArgs);
+//            } catch (IOException e) {
+//                // TODO Auto-generated catch block
+//                e.printStackTrace();
+//            }*/
+//
+//
+//
+//            File f = new File("/reviseApp/"+CURRENT_REVISE_APP+"/smalis/");
+//            PermissionRecursiveFiles(f);
+//
+//
+//        }
+
+        //collaboroid
+        //This <application> in customized attribute executing
+        if (sa.getBoolean(
+                com.android.internal.R.styleable.AndroidManifestApplication_SAMDApp,
+                false)) {
+            ai.flags |= ApplicationInfo.FLAG_SAMD_APP;
+            IS_AGENT_APP = true;
+            CURRENT_AGENT_APP = (String)v.string;
+            makeDir(CURRENT_AGENT_APP);
+            AGENT_AM = sa.getResources().getAssets();
+            ValuesCopyAssets(AGENT_AM, CURRENT_AGENT_APP);
+            DrawableCopyAssets(AGENT_AM, CURRENT_AGENT_APP);
+            LayoutCopyAssets(AGENT_AM, CURRENT_AGENT_APP);
+
+            String[] baksmaliArgs = {"/system/priv-app/"+CURRENT_AGENT_APP+"/"+CURRENT_AGENT_APP+".apk", "-o",
+                    "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/baksmaliFolder/"};
+            try {
+                com.android.baksmali.main.main(baksmaliArgs);
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+            //check library
+            if(CURRENT_AGENT_APP.equals("MekoMosaicApp")){
+                Log.d("Mosaic","Mosaic in function");
+                File dcs = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/baksmaliFolder/dcs");
+                File move_dcs = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/smaliFolder/dcs");
+                moveFileAll(dcs, move_dcs);
+            }
+
+        }
 
         owner.baseHardwareAccelerated = sa.getBoolean(
                 com.android.internal.R.styleable.AndroidManifestApplication_hardwareAccelerated,
@@ -2630,10 +2793,10 @@
             }
             ai.processName = buildProcessName(ai.packageName, null, pname,
                     flags, mSeparateProcesses, outError);
-    
+
             ai.enabled = sa.getBoolean(
                     com.android.internal.R.styleable.AndroidManifestApplication_enabled, true);
-            
+
             if (sa.getBoolean(
                     com.android.internal.R.styleable.AndroidManifestApplication_isGame, false)) {
                 ai.flags |= ApplicationInfo.FLAG_IS_GAME;
@@ -2680,9 +2843,9 @@
                     mParseError = PackageManager.INSTALL_PARSE_FAILED_MANIFEST_MALFORMED;
                     return false;
                 }
-
                 owner.activities.add(a);
 
+
             } else if (tagName.equals("receiver")) {
                 Activity a = parseActivity(owner, res, parser, attrs, flags, outError, true, false);
                 if (a == null) {
@@ -2852,7 +3015,7 @@
      * omitted here.
      */
     private boolean parseSplitApplication(Package owner, Resources res, XmlPullParser parser,
-            AttributeSet attrs, int flags, int splitIndex, String[] outError)
+                                          AttributeSet attrs, int flags, int splitIndex, String[] outError)
             throws XmlPullParserException, IOException {
         TypedArray sa = res.obtainAttributes(attrs,
                 com.android.internal.R.styleable.AndroidManifestApplication);
@@ -2983,8 +3146,8 @@
     }
 
     private boolean parsePackageItemInfo(Package owner, PackageItemInfo outInfo,
-            String[] outError, String tag, TypedArray sa,
-            int nameRes, int labelRes, int iconRes, int logoRes, int bannerRes) {
+                                         String[] outError, String tag, TypedArray sa,
+                                         int nameRes, int labelRes, int iconRes, int logoRes, int bannerRes) {
         String name = sa.getNonConfigurationString(nameRes, 0);
         if (name == null) {
             outError[0] = tag + " does not specify android:name";
@@ -2992,7 +3155,7 @@
         }
 
         outInfo.name
-            = buildClassName(owner.applicationInfo.packageName, name, outError);
+                = buildClassName(owner.applicationInfo.packageName, name, outError);
         if (outInfo.name == null) {
             return false;
         }
@@ -3002,7 +3165,7 @@
             outInfo.icon = iconVal;
             outInfo.nonLocalizedLabel = null;
         }
-        
+
         int logoVal = sa.getResourceId(logoRes, 0);
         if (logoVal != 0) {
             outInfo.logo = logoVal;
@@ -3024,8 +3187,8 @@
     }
 
     private Activity parseActivity(Package owner, Resources res,
-            XmlPullParser parser, AttributeSet attrs, int flags, String[] outError,
-            boolean receiver, boolean hardwareAccelerated)
+                                   XmlPullParser parser, AttributeSet attrs, int flags, String[] outError,
+                                   boolean receiver, boolean hardwareAccelerated)
             throws XmlPullParserException, IOException {
         TypedArray sa = res.obtainAttributes(attrs, R.styleable.AndroidManifestActivity);
 
@@ -3041,12 +3204,13 @@
                     R.styleable.AndroidManifestActivity_description,
                     R.styleable.AndroidManifestActivity_enabled);
         }
-        
+
         mParseActivityArgs.tag = receiver ? "<receiver>" : "<activity>";
         mParseActivityArgs.sa = sa;
         mParseActivityArgs.flags = flags;
-        
+
         Activity a = new Activity(mParseActivityArgs, new ActivityInfo());
+
         if (outError[0] != null) {
             sa.recycle();
             return null;
@@ -3091,6 +3255,8 @@
                 owner.applicationInfo.taskAffinity, str, outError);
 
         a.info.flags = 0;
+
+
         if (sa.getBoolean(
                 R.styleable.AndroidManifestActivity_multiprocess, false)) {
             a.info.flags |= ActivityInfo.FLAG_MULTIPROCESS;
@@ -3103,7 +3269,6 @@
         if (sa.getBoolean(R.styleable.AndroidManifestActivity_clearTaskOnLaunch, false)) {
             a.info.flags |= ActivityInfo.FLAG_CLEAR_TASK_ON_LAUNCH;
         }
-
         if (sa.getBoolean(R.styleable.AndroidManifestActivity_noHistory, false)) {
             a.info.flags |= ActivityInfo.FLAG_NO_HISTORY;
         }
@@ -3140,6 +3305,7 @@
 
         if (sa.getBoolean(R.styleable.AndroidManifestActivity_primaryUserOnly, false)) {
             a.info.flags |= ActivityInfo.FLAG_PRIMARY_USER_ONLY;
+
         }
 
         if (!receiver) {
@@ -3168,6 +3334,95 @@
                 a.info.flags |= ActivityInfo.FLAG_ALLOW_EMBEDDED;
             }
 
+            //collaboroid
+
+            if(IS_AGENT_APP){
+                if (sa.getBoolean(R.styleable.AndroidManifestActivity_remoteable, false)) {
+                    AGENT_RES = sa.getResources();
+                    //MOVE SMALI TO ORIGINALSMALI FOLDER
+                    String fullName = a.getComponentName().getClassName();
+                    String activityName = fullName.replace(a.getComponentName().getPackageName()+".","");
+                    String PackageName = fullName.replace("."+activityName , "");
+                    CURRENT_AGENT_PACKAGE = PackageName;
+                    CURRENT_AGENT_ACTIVITY = activityName;
+
+                    String temppackageName = CURRENT_AGENT_PACKAGE.replace(".","/");
+                    File sourceFile = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/baksmaliFolder/"+temppackageName);
+                    File targetFile = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/originalSmali");
+                    //copy com/TexasHoldem/activities -> originalSmali [Partial]
+
+                    moveFile(sourceFile, targetFile, CURRENT_AGENT_ACTIVITY);
+                    //17.01.19
+                    //Save HashMap for smali $$$$
+                    smali$FileList.put(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY, getFileList(targetFile.getAbsolutePath(), activityName));
+                    String[] sf = smali$FileList.get(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+
+                    //get PlayerActivity$1.smali
+
+                    //Resource save
+                    List<String> all0x7fs = getAll0x7f(sf, CURRENT_AGENT_APP);
+                    ArrayList<String> subOfall0x7fs = new ArrayList<String>();
+                    //add 0x to hashmap
+                    for(String s : all0x7fs){
+                        subOfall0x7fs.add(getResNameOrID(Integer.parseInt(s.substring(2,10), 16),AGENT_AM, AGENT_RES));
+                    }
+                    //modified content && originalSmali -> modifiedSmali
+
+                    ResourceTable.put(CURRENT_AGENT_APP, replaceContentOfActivity(all0x7fs, subOfall0x7fs));
+
+                    HashMap<String, List<String>> temp = ResourceTable.get(CURRENT_AGENT_APP);
+                    List<String> temp2 = temp.get(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+
+
+                    writeResourceTable(ResourceTable.get(CURRENT_AGENT_APP).get(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY));
+
+                    //rename [modifiedSmali folder smali name] -> [com/collaboroid/dummy2 smali name] MainActivity
+                    renameActivityToMainDummy1(CURRENT_AGENT_ACTIVITY);
+                    renameActivityToMainDummy2(CURRENT_AGENT_ACTIVITY);
+
+                    String[] smaliArgs = {"-o",
+                            "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/dex/"+CURRENT_AGENT_ACTIVITY+"_classes.dex",
+                            "--",
+                            "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/smaliFolder"};
+                    com.android.smali.main.main(smaliArgs);
+                    Log.d("samd experiment","APK remoateable make dex end");
+                    //17.05.16
+                    DeleteRecursiveFiles(new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/smaliFolder/com/collaboroid/dummy1"));
+                    DeleteRecursiveFiles(new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/smaliFolder/com/collaboroid/dummy2"));
+
+                }else{
+                    String fullName = a.getComponentName().getClassName();
+                    String activityName = fullName.replace(a.getComponentName().getPackageName()+".","");
+                    String PackageName = fullName.replace("."+activityName , "");
+
+                    CURRENT_AGENT_PACKAGE = PackageName;
+                    CURRENT_AGENT_ACTIVITY = activityName;
+
+                    String temppackageName = CURRENT_AGENT_PACKAGE.replace(".","/");
+
+                    File sourceFile = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/baksmaliFolder/"+temppackageName);
+                    File targetFile = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/"+"originalSmali");
+
+
+                    moveFile(sourceFile, targetFile, activityName);
+                    smali$FileList.put(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY, getFileList(targetFile.getAbsolutePath(), activityName));
+                    String[] sf = smali$FileList.get(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+
+                    makeActivityTable(sf);
+
+                    List<String> activities = new ArrayList<>();
+                    HashMap<String, List<String>> mainActivity = new HashMap<>();
+
+                    mainActivity = ActivityTable.get(CURRENT_AGENT_APP);
+                    activities = mainActivity.get(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+                    writeActivityTable(activities);
+                    //write txt file in android device[data/collaboroid/preprocess/CURRENT_AGENT_APP/..]
+
+                }
+
+            }
+
+
             if (sa.getBoolean(R.styleable.AndroidManifestActivity_autoRemoveFromRecents, false)) {
                 a.info.flags |= ActivityInfo.FLAG_AUTO_REMOVE_FROM_RECENTS;
             }
@@ -3219,7 +3474,7 @@
                 outError[0] = "Heavy-weight applications can not have receivers in main process";
             }
         }
-        
+
         if (outError[0] != null) {
             return null;
         }
@@ -3227,8 +3482,8 @@
         int outerDepth = parser.getDepth();
         int type;
         while ((type=parser.next()) != XmlPullParser.END_DOCUMENT
-               && (type != XmlPullParser.END_TAG
-                       || parser.getDepth() > outerDepth)) {
+                && (type != XmlPullParser.END_TAG
+                || parser.getDepth() > outerDepth)) {
             if (type == XmlPullParser.END_TAG || type == XmlPullParser.TEXT) {
                 continue;
             }
@@ -3298,7 +3553,7 @@
     }
 
     private Activity parseActivityAlias(Package owner, Resources res,
-            XmlPullParser parser, AttributeSet attrs, int flags, String[] outError)
+                                        XmlPullParser parser, AttributeSet attrs, int flags, String[] outError)
             throws XmlPullParserException, IOException {
         TypedArray sa = res.obtainAttributes(attrs,
                 com.android.internal.R.styleable.AndroidManifestActivityAlias);
@@ -3332,10 +3587,10 @@
                     com.android.internal.R.styleable.AndroidManifestActivityAlias_enabled);
             mParseActivityAliasArgs.tag = "<activity-alias>";
         }
-        
+
         mParseActivityAliasArgs.sa = sa;
         mParseActivityAliasArgs.flags = flags;
-        
+
         Activity target = null;
 
         final int NA = owner.activities.size();
@@ -3420,8 +3675,8 @@
         int outerDepth = parser.getDepth();
         int type;
         while ((type=parser.next()) != XmlPullParser.END_DOCUMENT
-               && (type != XmlPullParser.END_TAG
-                       || parser.getDepth() > outerDepth)) {
+                && (type != XmlPullParser.END_TAG
+                || parser.getDepth() > outerDepth)) {
             if (type == XmlPullParser.END_TAG || type == XmlPullParser.TEXT) {
                 continue;
             }
@@ -3465,7 +3720,7 @@
     }
 
     private Provider parseProvider(Package owner, Resources res,
-            XmlPullParser parser, AttributeSet attrs, int flags, String[] outError)
+                                   XmlPullParser parser, AttributeSet attrs, int flags, String[] outError)
             throws XmlPullParserException, IOException {
         TypedArray sa = res.obtainAttributes(attrs,
                 com.android.internal.R.styleable.AndroidManifestProvider);
@@ -3483,10 +3738,10 @@
                     com.android.internal.R.styleable.AndroidManifestProvider_enabled);
             mParseProviderArgs.tag = "<provider>";
         }
-        
+
         mParseProviderArgs.sa = sa;
         mParseProviderArgs.flags = flags;
-        
+
         Provider p = new Provider(mParseProviderArgs, new ProviderInfo());
         if (outError[0] != null) {
             sa.recycle();
@@ -3524,7 +3779,7 @@
             p.info.readPermission = owner.applicationInfo.permission;
         } else {
             p.info.readPermission =
-                str.length() > 0 ? str.toString().intern() : null;
+                    str.length() > 0 ? str.toString().intern() : null;
         }
         str = sa.getNonConfigurationString(
                 com.android.internal.R.styleable.AndroidManifestProvider_writePermission, 0);
@@ -3535,7 +3790,7 @@
             p.info.writePermission = owner.applicationInfo.permission;
         } else {
             p.info.writePermission =
-                str.length() > 0 ? str.toString().intern() : null;
+                    str.length() > 0 ? str.toString().intern() : null;
         }
 
         p.info.grantUriPermissions = sa.getBoolean(
@@ -3575,7 +3830,7 @@
                 return null;
             }
         }
-        
+
         if (cpname == null) {
             outError[0] = "<provider> does not include authorities attribute";
             return null;
@@ -3594,14 +3849,14 @@
     }
 
     private boolean parseProviderTags(Resources res,
-            XmlPullParser parser, AttributeSet attrs,
-            Provider outInfo, String[] outError)
+                                      XmlPullParser parser, AttributeSet attrs,
+                                      Provider outInfo, String[] outError)
             throws XmlPullParserException, IOException {
         int outerDepth = parser.getDepth();
         int type;
         while ((type=parser.next()) != XmlPullParser.END_DOCUMENT
-               && (type != XmlPullParser.END_TAG
-                       || parser.getDepth() > outerDepth)) {
+                && (type != XmlPullParser.END_TAG
+                || parser.getDepth() > outerDepth)) {
             if (type == XmlPullParser.END_TAG || type == XmlPullParser.TEXT) {
                 continue;
             }
@@ -3618,7 +3873,7 @@
                         outInfo.metaData, outError)) == null) {
                     return false;
                 }
-                
+
             } else if (parser.getName().equals("grant-uri-permission")) {
                 TypedArray sa = res.obtainAttributes(attrs,
                         com.android.internal.R.styleable.AndroidManifestGrantUriPermission);
@@ -3642,7 +3897,7 @@
                 if (str != null) {
                     pa = new PatternMatcher(str, PatternMatcher.PATTERN_SIMPLE_GLOB);
                 }
-                
+
                 sa.recycle();
 
                 if (pa != null) {
@@ -3689,7 +3944,7 @@
                 if (writePermission == null) {
                     writePermission = permission;
                 }
-                
+
                 boolean havePerm = false;
                 if (readPermission != null) {
                     readPermission = readPermission.intern();
@@ -3712,7 +3967,7 @@
                         return false;
                     }
                 }
-                
+
                 String path = sa.getNonConfigurationString(
                         com.android.internal.R.styleable.AndroidManifestPathPermission_path, 0);
                 if (path != null) {
@@ -3777,7 +4032,7 @@
     }
 
     private Service parseService(Package owner, Resources res,
-            XmlPullParser parser, AttributeSet attrs, int flags, String[] outError)
+                                 XmlPullParser parser, AttributeSet attrs, int flags, String[] outError)
             throws XmlPullParserException, IOException {
         TypedArray sa = res.obtainAttributes(attrs,
                 com.android.internal.R.styleable.AndroidManifestService);
@@ -3795,10 +4050,10 @@
                     com.android.internal.R.styleable.AndroidManifestService_enabled);
             mParseServiceArgs.tag = "<service>";
         }
-        
+
         mParseServiceArgs.sa = sa;
         mParseServiceArgs.flags = flags;
-        
+
         Service s = new Service(mParseServiceArgs, new ServiceInfo());
         if (outError[0] != null) {
             sa.recycle();
